unit MyFunc;

interface

uses
   Math ;

const
   _LIMIT = 0.00000001;
   _LIMITN = 0.0000000001;

   function SInt(s:string):integer ;
   function SDbl(s:string):double ;
   function Dist(x1,y1,x2,y2:double):double ;
   function Angle(dx,dy:double):double ;
   procedure Rev(var rx,ry:double;x,y,cx,cy,a:double) ;
	function KTrim(s:string): string ;

implementation

// 񁨐
function SInt(s:string):integer ;
var
   a,i : integer ;
begin
   if (s <> '') then begin
      Val(s,a,i);
      if (i <> 0) then
         a := 0;
   end
   else
      a := 0;
   Result := a;
end;

// 񁨎(double)
function SDbl(s:string):double ;
var
   a : double ;
   i : integer ;
begin
   if (s <> '') then begin
      Val(s,a,i);
      if (i <> 0) then
         a := 0.0;
   end
   else
      a := 0.0;
   Result := a;
end;

// ijvZ
//@@x1,y1 : n_
//@@x2,y2 : I_
//@@out : ()
function Dist(x1,y1,x2,y2:double):double ;
begin
	Result := Sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1)) ;
end;

// pxvZ
//@@dx : X
//@@dy : Y
//@@out: px (0`2*Pi)
function Angle(dx,dy:double):double ;
var
   r : double ;
begin
	Result := 0.0 ;
	if (Abs(dx) < _LIMITN)and(Abs(dy) < _LIMITN) then exit ;
	r := ArcTan2(dy,dx);
	if (r < 0.0) then r := r + 2.0 * Pi ;
   Result := r ;
end;

// ]
//    rx,ry : ]̍W
//    x ,y  : W
//    cx,cy : ]SW
//    a     : ]px[]
procedure Rev(var rx,ry:double;x,y,cx,cy,a:double) ;
var
   an : double ;  // WAl
begin
   an := a/180.0*Pi ;
   rx := cx + (x-cx)*Cos(an) - (y-cy)*Sin(an) ;
   ry := cy + (x-cy)*Sin(an) + (y-cy)*Cos(an) ;
end;



// 󔒁iSp^pj菜
function KTrim(s:string): string ;
var
   i,i1:Integer ;
	r,t : string ;
begin
	r := '' ;
	i := 1 ;
	i1 := Length(s) ;
	while(i <= i1) do begin
		if (Ord(s[i]) >= 128)and(Ord(s[i]) <= 159)
       or(Ord(s[i]) >= 224)and(Ord(s[i]) <= 253) then begin
      	// 
			t := s[i]+s[i+1] ;
			if (t <> '@') then r := r + t ;
			i := i + 2 ;
		end
      else begin
      	// ANK
			t := s[i] ;
			if (t <> ' ')and(Ord(s[i]) >= 32) then r := r + t ;
	      Inc(i);
      end;
   end;
	Result := r ;
end;

end.
